//---------------------------------------------------------------------------
// CUBRID ADO CONNECTION SAMPLE CODE FOR C++BUILDER
// BY PROTOTYPE ( prototype@cubrid.com )
// 2009.05.02
//
#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

#define BUFFER_SIZE		1024
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Form  ʰ ÿ Connection  Ѵ.
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	String ConnStr;
	String Provider, DataSrc, Location;
	String UserID, Passwd, Port, Addition;

	Provider = "Provider=CUBRIDProvider";
	DataSrc  = "Data Source=demodb";
	Location = "Location=localhost";
	UserID   = "User ID=dba";
	Passwd   = "Password=";
	Port     = "Port=30000";
	Addition = "Fetch Size=100";

	ConnStr.sprintf("%s;%s;%s;%s;%s;%s;%s"
		,Provider,DataSrc,Location,UserID,Passwd,Port,Addition);

	try {
		ADOConn->ConnectionString = ConnStr;
		ADOConn->CursorLocation = clUseServer;
		ADOConn->Connected = true;
		MMOutput->Lines->Add("Ǿϴ.");
	} catch (...) {
		MMOutput->Lines->Add(" ");	
	}
}
//---------------------------------------------------------------------------
// Form  Destory   Connection  Ǿ  Ѵ.
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
	if (ADOConn->Connected == true) {
		ADOConn->Connected = false;
	}
}
//---------------------------------------------------------------------------
// select * from nation ̶   Ѵ.
//   DataSource  Ͽ DBGrid ǥõȴ. 
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnExecuteClick(TObject *Sender)
{
	String sql = "select * from nation";

	try {
		ADOQuery->LockType = ltReadOnly;
		ADOQuery->CursorType = ctOpenForwardOnly;
		ADOQuery->SQL->Text = sql;
		ADOQuery->Open();
	} catch (...) {
		MMOutput->Lines->Add(" ");	
	}	
}
//---------------------------------------------------------------------------
// select * from nation ̶   Ѵ.
//   ؽƮ Memo Ʈѿ Ѵ.
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnRawExecuteClick(TObject *Sender)
{
	String TmpStr;
	String sql = "select * from nation";

	try {
		ADORawQuery->LockType = ltReadOnly;
		ADORawQuery->CursorType = ctOpenForwardOnly;
		ADORawQuery->SQL->Text = sql;
		ADORawQuery->Open();

		MMOutput->Lines->Add(ADORawQuery->SQL->Text);
		MMOutput->Lines->Add(String().sprintf("TOTAL ROWS : %d", 
			ADORawQuery->RecordCount));

		ADORawQuery->First();
		while (!ADORawQuery->Eof) {
			TmpStr.sprintf("%s, %s, %s, %s", 
				ADORawQuery->FieldByName("code")->AsString,
				ADORawQuery->FieldByName("name")->AsString,
				ADORawQuery->FieldByName("continent")->AsString,
				ADORawQuery->FieldByName("capital")->AsString
			);
			MMOutput->Lines->Add(TmpStr);
			ADORawQuery->Next();
		}
	} catch (...) {
		MMOutput->Lines->Add(" ");	
	}	
}
//---------------------------------------------------------------------------

